/*
author>
            Matthias Hader (R/GA)
            Nick Coronges (R/GA)
            Jeff Baxter (R/GA) - Design
</author>
<company>NIKE</company>
<copyright>(c)2006 NIKE ALL RIGHTS RESERVED</copyright>
 */
//debug
var debugMode = false;
var testMode = false;
//live
var baseURL = "http://www.nike.com";
var baseURLssl = "https://www.nike.com";
//test
var baseURLsslTest = "http://nike-dev2.ny.rga.com";


//XML Http Requests
var reqLogout;
var reqGeneratePin;
var reqGetToken;
var reqTokenLogin;
var reqGetGoals;
var reqValidateWidget;

var g_bsessionid;
var g_selectedGoalID;
var g_selectedGoalTitle;
var g_goalDetailDOM;

//widget validation information
var widgetName = "goalDesktopWidget";
var widgetEngine = "MacOSDashboard";
var widgetVersion = "0.9";

//status of log in
var g_loggedIN = false;

function setup(){
	if(debugMode == true) document.getElementById('debug').style.display = "block";
	if(testMode == true) baseURLssl = baseURLsslTest;
	//load assets
	if (assetsLoaded == false) loadAssets();
	
	//get preferences if possible
	var username = "";
	if (window.widget){
		//get saved username and set it in the username field
		username = getUsernamePreference();
	}
	document.getElementById("usernameField").value = username;
	
	var pin = "";
	var goalID="";
	if (window.widget){
		//fetch pin
		pin = getPinPreference();
		//fetch last viewed challenge
		debug("fetch last viewed challenge");
		goalID = getlastGoalIDPreference();
	}
	debug("setup pin pref:"+pin);
	debug("setup pin last goal pref:"+goalID);
	//proceed according to the preferences
	if(pin == ""){
		debug("no pin hide button and flip");
		hideDoneButton();
		flipSide('front','back','ToBack');
	}
	else if (goalID == ""){
		hideDoneButton();
		showLogoutButton();
		flipSide('front','back','ToBack');
		debug("last goal was empty! get token and session");
		processGetTokenAndSessionID(pin);
	}
	else{
		debug("show done button and get token and session");
		showLogoutButton();
		processGetTokenAndSessionID(pin);	
	}
}

function validateWidget(){
    //notifyLoadingSequenceStart();
    serviceURL = baseURL + "/nikeplus/v1/services/widget/check_version.jhtml";
    var product = widgetName+"_"+widgetEngine+"_v"+widgetVersion;
    reqValidateWidget = new XMLHttpRequest();
    reqValidateWidget.onreadystatechange = processReqValidateChange;
    reqValidateWidget.open("POST", serviceURL, true);
    reqValidateWidget.send("product="+product);
}
 
function processReqValidateChange(){
    //notifyLoadingSequenceStop();
	if (reqValidateWidget.readyState == 4) {
	    if (reqValidateWidget.status == 200) {
			var allResponseHeaders = reqValidateWidget.getAllResponseHeaders();
			temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
			if(temp_bsessionid != ""){
				g_bsessionid = temp_bsessionid;
			} 
			debug("validate bsessionid: "+g_bsessionid);
	        var serviceStatus =  reqValidateWidget.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
	            isCurrentVersion =  reqValidateWidget.responseXML.getElementsByTagName("isCurrentVersion")[0].firstChild.data;
				if(isCurrentVersion == "true"){
					setup();
	            }
	            else{
	                flipSide('front','back','ToBack');
	                downloadLink =  reqValidateWidget.responseXML.getElementsByTagName("downloadLink")[0].firstChild.data;
	                forceUpgrade = reqValidateWidget.responseXML.getElementsByTagName("forceUpgrade")[0].firstChild.data;
	                serviceMessage =  reqValidateWidget.responseXML.getElementsByTagName("message")[0].firstChild.data;
	                if(forceUpgrade == "true"){
                        popUpMessageBoxWithLink(false,serviceMessage,downloadLink);
	                }
	                else{
                        popUpMessageBoxWithLink(true,serviceMessage,downloadLink);
	                }
	            }
	        }
	        else{
                popUpMessageBox(true,"We just can't connect right now. Try again later.");
	        }
	    }
	    else{
            popUpMessageBox(true,"We just can't connect right now. Try again later.");
	    }
	}
	else if(reqValidateWidget.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
	}
}

function processLogout(){
	serviceURL = baseURLssl + "/services/profileService?action=logout";
	reqLogout = new XMLHttpRequest();
	reqLogout.onreadystatechange = processReqLogout;
	if(g_bsessionid != "") reqLogout.setRequestHeader("Cookie", g_bsessionid);
	reqLogout.open("POST", serviceURL, true);
	reqLogout.send(null);
}

function processReqLogout(){
	if (reqLogout.readyState == 4) {
		if (reqLogout.status == 200) {
		}
	}
}


function processLogin(username,password){
	if((username != "") && (password != "")){
		//notifyLoadingSequenceStart();
		debug("process login: "+username+"/"+password);
		serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_pin.jhtml";
		reqGeneratePin = new XMLHttpRequest();
	    reqGeneratePin.onreadystatechange = processReqGeneratePinChange; 
		if(g_bsessionid != "") reqGeneratePin.setRequestHeader("Cookie", g_bsessionid);
	    reqGeneratePin.open("POST", serviceURL, true);
	    reqGeneratePin.send("login="+username+"&password="+password);
	}
	else{
		popUpMessageBox(true,"You've got to log in to see your status, so enter your username and password.");
		showLoginButton();
	}
}


function processReqGeneratePinChange(){
	if (reqGeneratePin.readyState == 4) {
		if (reqGeneratePin.status == 200) {
			var serviceStatus =  reqGeneratePin.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGeneratePin.getAllResponseHeaders();
				temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				if(temp_bsessionid != ""){
					g_bsessionid = temp_bsessionid;
				} 
				debug("generate pin bsessionid: "+g_bsessionid);
				var pin = reqGeneratePin.responseXML.getElementsByTagName("pin")[0].firstChild.data;
				debug("generate pin: "+pin);
				if (window.widget){
					setPinPreference(pin);
				}
				showLogoutButton();
				processGetToken(pin);
			}
			else{
                var errorCode =  reqGeneratePin.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
                showLoginButton();
	        }
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
            showLoginButton();
		}
	}
	 else if(reqGeneratePin.readyState == 0){
	    popUpMessageBox(true,"We just can't connect right now. Try again later.");
	    showLoginButton();
    }
}

function processGetToken(pin){
	//notifyLoadingSequenceStart();
    serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = processReqGetTokenChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
	reqGetToken.setRequestHeader("Cookie", g_bsessionid);
    reqGetToken.send(null);
}

function processReqGetTokenChange(){
	if (reqGetToken.readyState == 4) {
		if (reqGetToken.status == 200) {
			var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGetToken.getAllResponseHeaders();
				if(g_bsessionid == "") g_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				debug("get token bsessionid: "+g_bsessionid);
				var token = reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug("get token: "+token);
				processTokenLogin(token);
			}
			else{
				var errorCode =  reqGeneratePin.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
			}
		}
		else{
			 popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	 else if(reqGetToken.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function processGetTokenAndSessionID(pin){
    serviceURL = baseURLssl + "/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = processReqGetTokenAndSessionIDChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
    reqGetToken.send(null);
}

function processReqGetTokenAndSessionIDChange(){
	if (reqGetToken.readyState == 4) {
		if (reqGetToken.status == 200) {
			var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
			if(serviceStatus == "success"){
				var allResponseHeaders = reqGetToken.getAllResponseHeaders();
				temp_bsessionid = getBSESSIONIDKeyValue(allResponseHeaders);
				if(temp_bsessionid != ""){
					g_bsessionid = temp_bsessionid;
				} 
				debug("get token bsessionid: "+g_bsessionid);
				var token = reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug("get token: "+token);
				processTokenLogin(token);
			}
			else{
				var errorCode =  reqGetToken.responseXML.getElementsByTagName("serviceException")[0].getAttribute("errorCode");
                popUpMessageBox(true,"Something wasn't quite right. Try entering your info again.");
			}
		}
		else{
			 popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	 else if(reqGetToken.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}


function processTokenLogin(token){
    serviceURL = baseURL + "/nikeplus/v1/services/widget/token_login.jhtml";
    reqTokenLogin = new XMLHttpRequest();
    reqTokenLogin.onreadystatechange = processReqTokenLoginChange;
    reqTokenLogin.open("POST", serviceURL, true);
	reqTokenLogin.setRequestHeader("Cookie", g_bsessionid);
    reqTokenLogin.send("token="+token);
}

function processReqTokenLoginChange(){
	if (reqTokenLogin.readyState == 4) {
		if (reqTokenLogin.status == 200) {
			debug("process get gaol");
			processGetGoals();
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
        }
    }
    else if(reqTokenLogin.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function processGetGoals(){
	//alert("process get goals");
	serviceURL = "https://www.nike.com/nikeplus/v1/services/app/goal_list.jhtml";
    reqGetGoals = new XMLHttpRequest();
    reqGetGoals.onreadystatechange = processReqGetGoalsChange;
    reqGetGoals.open("POST", serviceURL, true);
	reqGetGoals.setRequestHeader("Cookie", g_bsessionid);
    reqGetGoals.send(null);
}

function processReqGetGoalsChange(){
	if (reqGetGoals.readyState == 4) {
		if (reqGetGoals.status == 200) {
			g_goalDetailDOM = reqGetGoals.responseXML;
			var html =  getGoalSelectBox(g_goalDetailDOM);
			if(html != ""){
				document.getElementById("goalSelectContainer").innerHTML = html;
				//if there is a last goalID saved -> load it
				if(window.widget){
					lastGoalID = getlastGoalIDPreference()
					if( lastGoalID != ""){
						setSelectedGoal();
					}
				}
				//show the goal Selector
				showGoalSelector();
			}
			else{
				popUpMessageBox(true,"You have to set a Nike+ Goal to see it here. Set one at nikeplus.com.");
			}
		}
		else{
			popUpMessageBox(true,"We just can't connect right now. Try again later.");
		}
	}
	else if(reqGetGoals.readyState == 0){
        popUpMessageBox(true,"We just can't connect right now. Try again later.");
    }
}

function getGoalSubtitle(goalID,goalDOM){
	var goalNodeIterator = goalDOM.getElementsByTagName("goal");
	var endTime = "";
	for(var i=0;i<goalNodeIterator.length;i++){
		var nodesGoalID = goalDOM.getElementsByTagName("goal")[i].getAttribute("id");
		if(nodesGoalID == goalID){
			endTime = goalDOM.getElementsByTagName("goal")[i].childNodes[7].firstChild.data;
		}
	}
	if(endTime != ""){
		var subtitle = "";
		var daysLeft = getDaysLeftFromNow(endTime);
		if(daysLeft == "1"){
			return "1 day remaining";
		}
		else{
			return daysLeft + " days remaining";
		}
	}
	else{
		return "";
	}
}

function getGoalDetail(goalDOM,goalID){
	var goalNodeIterator = goalDOM.getElementsByTagName("goal");
	for(var i=0;i<goalNodeIterator.length;i++){
		var nodesGoalID = goalDOM.getElementsByTagName("goal")[i].getAttribute("id");
		if(nodesGoalID == goalID){
			var ended = false;
			var html = 
				"<div id=\"progressBarBackground\"></div>";
			var startTime = goalDOM.getElementsByTagName("goal")[i].childNodes[5].firstChild.data;
			var endTime = goalDOM.getElementsByTagName("goal")[i].childNodes[7].firstChild.data;
			var goalDefinitionNode = goalDOM.getElementsByTagName("definition")[i];
			var completed = goalDOM.getElementsByTagName("goal")[i].childNodes[1].firstChild.data;
			goalType = goalDefinitionNode.childNodes[1].firstChild.data;
			var overlayGreenWidth = 31;
			var targetOffset = -1;
			var runnerOffset = -8;
			var targetLeft = targetOffset;
			var runnerLeft = runnerOffset;
			//time calculation
			var timeRangeInMillis = getMilliDifference(startTime,endTime);
			var timePassedMilli = getMillisPassed(startTime);
			if(timePassedMilli > timeRangeInMillis){
				timePassedMilli = timeRangeInMillis + 36000000;
				ended = true;
				document.getElementById("goalSubtitleContainer").innerHTML = "Sorry, time's up!";
			}
			//max bar section
			var maxBarSection = 268;
			switch(goalType){
				case "runCalories":
					//unit calculation
					var caloriesGoal = goalDefinitionNode.childNodes[3].firstChild.data;
					var pixelPerCalorie = maxBarSection/caloriesGoal;
					//time/calories calculation
					var caloriesPerMilli = caloriesGoal/timeRangeInMillis;
					//owed calories
					var burnedCaloriesOwed = Math.round(timePassedMilli*caloriesPerMilli);
					//actual calories
					var burnedCaloriesProgress = goalDefinitionNode.childNodes[5].firstChild.data;
					if(completed == "true"){
						//set new subtitle to goal completed
						document.getElementById("goalSubtitleContainer").innerHTML = "Congratulations! You achieved your goal.";
						//set text at the right end of the bar 
						var burnedCaloriesGoalText = caloriesGoal+"calories";
						var burnedCaloriesProgressTextWidthPixel = burnedCaloriesGoalText.length * 10;
						var textLeftPosition = 340 - burnedCaloriesProgressTextWidthPixel;
						statusTextStyle = "color:#FFFFFF;text-align:right;width:"+burnedCaloriesProgressTextWidthPixel+";left:"+textLeftPosition;
						//set runner bubble to the right end of the bar
						runnerLeft += 330;
						
						html +=	
						"<div id=\"progressBarOverlayGold\"></div>"+
						"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+burnedCaloriesGoalText+"</div>"+
						"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					else{
						if(parseInt(burnedCaloriesOwed,10) > 0){
							var burnedCaloriesOwedText = burnedCaloriesOwed+"calories";
							var caloriesOwedTextWidthPixel = burnedCaloriesOwedText.length * 5;
							var burnedCaloriesOwedPixels = Math.round(pixelPerCalorie * burnedCaloriesOwed);
							//prevent overflow
							if(burnedCaloriesOwedPixels>maxBarSection) {
								burnedCaloriesOwedPixels = maxBarSection;
								burnedCaloriesOwedText = caloriesGoal+"calories";
								caloriesOwedTextWidthPixel = burnedCaloriesOwedText.length * 5;
								html += 
								"<div id=\"progressBarOverlayGrayTargetEnd\"></div>";
								targetLeft += overlayGreenWidth+maxBarSection+31;
							}
							else {
								targetLeft += overlayGreenWidth+burnedCaloriesOwedPixels;
							}
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + burnedCaloriesOwedPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > caloriesOwedTextWidthPixel){
								targetTextLeft = targetLeft - caloriesOwedTextWidthPixel;
								statusTextStyle = "width:"+caloriesOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:right";
							}
							else{
								targetTextLeft = targetLeft + 35;
								statusTextStyle = "width:"+caloriesOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:left";
							}
							
							html += 
								"<div id=\"progressBarOverlayGrayTargetStart\"></div>"+
								"<div id=\"progressBarOverlayGrayTargetSections\" style=\"width:"+burnedCaloriesOwedPixels+"px\"></div>"+
								"<div id=\"progressBarTargetStatusText\" style=\""+statusTextStyle+"\">"+burnedCaloriesOwedText+"</div>";
						}
						if(parseInt(burnedCaloriesProgress,10) > 0){
							var burnedCaloriesProgressText = burnedCaloriesProgress+"calories";
							var burnedCaloriesProgressTextWidthPixel = burnedCaloriesProgressText.length * 10;
							var burnedCaloriesProgressPixels = Math.round(pixelPerCalorie * burnedCaloriesProgress);
							//prevent overflow
							if(burnedCaloriesProgressPixels>maxBarSection) burnedCaloriesProgressPixels = maxBarSection;
							runnerLeft += overlayGreenWidth+burnedCaloriesProgressPixels;
							whiteDelimiterLeft = 17 + overlayGreenWidth + burnedCaloriesProgressPixels;
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + burnedCaloriesProgressPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > burnedCaloriesProgressTextWidthPixel){
								runnerTextLeft = runnerLeft - burnedCaloriesProgressTextWidthPixel + 20;
								statusTextStyle = "width:"+burnedCaloriesProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:right;color:#FFFFFF";
							}
							else{
								runnerTextLeft = runnerLeft + 28;
								statusTextStyle = "width:"+burnedCaloriesProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:left;color:#333333";
							}
							
							html += 
								"<div id=\"progressBarOverlayGreenStart\"></div>"+
								"<div id=\"progressBarOverlayGreenSections\" style=\"width:"+burnedCaloriesProgressPixels+"px\"></div>"+
								"<div id=\"progressBarOverlayWhiteLine\" style=\"left:"+whiteDelimiterLeft+"\"></div>"+
								"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+burnedCaloriesProgressText+"</div>";
						}
						
						html +=	
							"<div id=\"progressBarOverlayTargetBubble\" style=\"left:"+targetLeft+"px\"></div>"+
							"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					break;
				case "runFurther":
					var distanceGoal = goalDefinitionNode.childNodes[3].firstChild.data;
					var displayUnit = goalDefinitionNode.childNodes[5].firstChild.data;
					var pixelsPerDistance = maxBarSection/distanceGoal;
					//time/run calculation
					var distancePerMilli = distanceGoal/timeRangeInMillis;
					//owed distance
					var distanceOwed = timePassedMilli*distancePerMilli;
					//actual distance
					var distanceProgress = goalDefinitionNode.childNodes[7].firstChild.data;
					if(completed == "true"){
						//set new subtitle to goal completed
						document.getElementById("goalSubtitleContainer").innerHTML = "Congratulations! You achieved your goal.";
						//set text at the right end of the bar 
						var distenceGoalText = getDisplayDistance(displayUnit,distanceGoal)+displayUnit;
						var distenceGoalTextWidthPixel = distenceGoalText.length * 10;
						var textLeftPosition = 340 - distenceGoalTextWidthPixel;
						statusTextStyle = "color:#FFFFFF;text-align:right;width:"+distenceGoalTextWidthPixel+";left:"+textLeftPosition;
						//set runner bubble to the right end of the bar
						runnerLeft += 330;
						
						html +=	
						"<div id=\"progressBarOverlayGold\"></div>"+
						"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+distenceGoalText+"</div>"+
						"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					else{
						if(parseFloat(distanceOwed,10) > 0){
							var distanceOwedText = getDisplayDistance(displayUnit,distanceOwed)+displayUnit;
							var distanceOwedTextWidthPixel = distanceOwedText.length * 6;
							var distanceOwedPixels = Math.round(pixelsPerDistance * distanceOwed);
							//prevent overflow
							if(distanceOwedPixels>maxBarSection){
								distanceOwedPixels = maxBarSection;
								distanceOwedText = getDisplayDistance(displayUnit,distanceGoal)+displayUnit;
								distanceOwedTextWidthPixel = distanceOwedPixels.length * 6;
								html += 
								"<div id=\"progressBarOverlayGrayTargetEnd\"></div>";
								targetLeft += overlayGreenWidth+maxBarSection+31;
							} 
							else{
								targetLeft += overlayGreenWidth+distanceOwedPixels;
							}
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + distanceOwedPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > distanceOwedTextWidthPixel){
								targetTextLeft = targetLeft - distanceOwedTextWidthPixel;
								statusTextStyle = "width:"+distanceOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:right";
							}
							else{
								targetTextLeft = targetLeft + 35;
								statusTextStyle = "width:"+distanceOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:left";
							}
							
							
							html += 
								"<div id=\"progressBarOverlayGrayTargetStart\"></div>"+
								"<div id=\"progressBarOverlayGrayTargetSections\" style=\"width:"+distanceOwedPixels+"px\"></div>"+
								"<div id=\"progressBarTargetStatusText\" style=\""+statusTextStyle+"\">"+distanceOwedText+"</div>";
						}
						if(parseFloat(distanceProgress,10) > 0){
							var distanceProgressText = getDisplayDistance(displayUnit,distanceProgress)+displayUnit;
							var distanceProgressTextWidthPixel = distanceProgressText.length * 10;
							var distanceProgressPixels = Math.round(pixelsPerDistance * distanceProgress);
							//prevent overflow
							if(distanceProgressPixels>maxBarSection) distanceProgressPixels = maxBarSection;
							runnerLeft += overlayGreenWidth+distanceProgressPixels;
							var whiteDelimiterLeft = 17 + overlayGreenWidth + distanceProgressPixels;
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + distanceProgressPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > distanceProgressTextWidthPixel){
								runnerTextLeft = runnerLeft - distanceProgressTextWidthPixel + 20;
								statusTextStyle = "width:"+distanceProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:right;color:#FFFFFF";
							}
							else{
								runnerTextLeft = runnerLeft + 28;
								statusTextStyle = "width:"+distanceProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:left;color:#333333";
							}
							
							html += 
								"<div id=\"progressBarOverlayGreenStart\"></div>"+
								"<div id=\"progressBarOverlayGreenSections\" style=\"width:"+distanceProgressPixels+"px\"></div>"+
								"<div id=\"progressBarOverlayWhiteLine\" style=\"left:"+whiteDelimiterLeft+"\"></div>"+
								"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+distanceProgressText+"</div>";
						}
						
						html +=	
							"<div id=\"progressBarOverlayTargetBubble\" style=\"left:"+targetLeft+"px\"></div>"+
							"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					break;
				case "runFaster": 
					var numberOfRunsGoal = goalDefinitionNode.childNodes[3].firstChild.data;
					var pixelsPerRun = maxBarSection/numberOfRunsGoal;
					//time/run calculation
					var runsPerMilli = numberOfRunsGoal/timeRangeInMillis;
					//owed runs
					var numberOfRunsOwed = Math.round(timePassedMilli*runsPerMilli);
					//actual runs
					var runsProgress = goalDefinitionNode.childNodes[5].firstChild.data;
					if(completed == "true"){
						//set new subtitle to goal completed
						document.getElementById("goalSubtitleContainer").innerHTML = "Congratulations! You achieved your goal.";
						//set text at the right end of the bar 
						var runsGoalText = numberOfRunsGoal+"runs";
						var runsTextWidthPixel = runsGoalText.length * 10;
						var textLeftPosition = 340 - runsTextWidthPixel;
						statusTextStyle = "color:#FFFFFF;text-align:right;width:"+runsTextWidthPixel+";left:"+textLeftPosition;
						//set runner bubble to the right end of the bar
						runnerLeft += 330;
						
						html +=	
						"<div id=\"progressBarOverlayGold\"></div>"+
						"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+runsGoalText+"</div>"+
						"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					else{
						if(parseInt(numberOfRunsOwed,10) > 0){
							var runsOwedText = numberOfRunsOwed+"runs";;
							var runsOwedTextWidthPixel = runsOwedText.length * 6;
							var runsOwedPixels = Math.round(pixelsPerRun * numberOfRunsOwed);
							//prevent overflow
							if(runsOwedPixels>maxBarSection){
								runsOwedPixels = maxBarSection;
								var runsOwedText = numberOfRunsGoal+"runs";;
								var runsOwedTextWidthPixel = runsOwedText.length * 6;
								html += 
								"<div id=\"progressBarOverlayGrayTargetEnd\"></div>";
								targetLeft += overlayGreenWidth+maxBarSection+31;
							} 
							else{
								targetLeft += overlayGreenWidth+runsOwedPixels;
							}
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + runsOwedPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > runsOwedTextWidthPixel){
								targetTextLeft = targetLeft - runsOwedTextWidthPixel;
								statusTextStyle = "width:"+runsOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:right";
							}
							else{
								targetTextLeft = targetLeft + 35;
								statusTextStyle = "width:"+runsOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:left";
							}
							
							html += 
								"<div id=\"progressBarOverlayGrayTargetStart\"></div>"+
								"<div id=\"progressBarOverlayGrayTargetSections\" style=\"width:"+runsOwedPixels+"px\"></div>"+
								"<div id=\"progressBarTargetStatusText\" style=\""+statusTextStyle+"\">"+runsOwedText+"</div>";
						}
						if(parseInt(runsProgress,10) > 0){
							var runsProgressText = runsProgress+"runs";
							var runsProgressTextWidthPixel = runsProgressText.length * 10;
							var runsProgressPixels = Math.round(pixelsPerRun * runsProgress);
							runnerLeft += overlayGreenWidth+runsProgressPixels;
							var whiteDelimiterLeft = 17 + overlayGreenWidth + runsProgressPixels;
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + runsProgressPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > runsProgressTextWidthPixel){
								runnerTextLeft = runnerLeft - runsProgressTextWidthPixel + 20;
								statusTextStyle = "width:"+runsProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:right;color:#FFFFFF";
							}
							else{
								runnerTextLeft = runnerLeft + 28;
								statusTextStyle = "width:"+runsProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:left;color:#333333";
							}
							html += 
								"<div id=\"progressBarOverlayGreenStart\"></div>"+
								"<div id=\"progressBarOverlayGreenSections\" style=\"width:"+runsProgressPixels+"px\"></div>"+
								"<div id=\"progressBarOverlayWhiteLine\" style=\"left:"+whiteDelimiterLeft+"px\"></div>"+
								"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+runsProgressText+"</div>";
						}
						
						html +=	
							"<div id=\"progressBarOverlayTargetBubble\" style=\"left:"+targetLeft+"px\"></div>"+
							"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					break;
				case "runMoreOften":
					var numberOfRunsGoal = goalDefinitionNode.childNodes[3].firstChild.data;
					var pixelsPerRun = maxBarSection/numberOfRunsGoal;
					//time/run calculation
					var runsPerMilli = numberOfRunsGoal/timeRangeInMillis;
					//owed runs
					var numberOfRunsOwed = Math.round(timePassedMilli*runsPerMilli);
					//actual runs
					var runsProgress = goalDefinitionNode.childNodes[5].firstChild.data;
					if(completed == "true"){
						//set new subtitle to goal completed
						document.getElementById("goalSubtitleContainer").innerHTML = "Congratulations! You achieved your goal.";
						//set text at the right end of the bar 
						var runsGoalText = numberOfRunsGoal+"runs";
						var runsTextWidthPixel = runsGoalText.length * 10;
						var textLeftPosition = 340 - runsTextWidthPixel;
						statusTextStyle = "color:#FFFFFF;text-align:right;width:"+runsTextWidthPixel+";left:"+textLeftPosition;
						//set runner bubble to the right end of the bar
						runnerLeft += 330;
						
						html +=	
						"<div id=\"progressBarOverlayGold\"></div>"+
						"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+runsGoalText+"</div>"+
						"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					else{
						if(parseInt(numberOfRunsOwed,10) > 0){
							var runsOwedText = numberOfRunsOwed+"runs";;
							var runsOwedTextWidthPixel = runsOwedText.length * 6;
							var runsOwedPixels = Math.round(pixelsPerRun * numberOfRunsOwed);
							//prevent overflow
							if(runsOwedPixels>maxBarSection){
								runsOwedPixels = maxBarSection;
								var runsOwedText = numberOfRunsGoal+"runs";;
								var runsOwedTextWidthPixel = runsOwedText.length * 6;
								html += 
								"<div id=\"progressBarOverlayGrayTargetEnd\"></div>";
								targetLeft += overlayGreenWidth+maxBarSection+31;
							} 
							else{
								targetLeft += overlayGreenWidth+runsOwedPixels;
							}
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + runsOwedPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > runsOwedTextWidthPixel){
								targetTextLeft = targetLeft - runsOwedTextWidthPixel;
								statusTextStyle = "width:"+runsOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:right";
							}
							else{
								targetTextLeft = targetLeft + 35;
								statusTextStyle = "width:"+runsOwedTextWidthPixel+"px;left:"+targetTextLeft+"px;text-align:left";
							}
							
							html += 
								"<div id=\"progressBarOverlayGrayTargetStart\"></div>"+
								"<div id=\"progressBarOverlayGrayTargetSections\" style=\"width:"+runsOwedPixels+"px\"></div>"+
								"<div id=\"progressBarTargetStatusText\" style=\""+statusTextStyle+"\">"+runsOwedText+"</div>";
						}
						if(parseInt(runsProgress,10) > 0){
							var runsProgressText = runsProgress+"runs";
							//alert(runsProgressText);
							var runsProgressTextWidthPixel = runsProgressText.length * 10;
							var runsProgressPixels = Math.round(pixelsPerRun * runsProgress);
							runnerLeft += overlayGreenWidth+runsProgressPixels;
							var whiteDelimiterLeft = 17 + overlayGreenWidth + runsProgressPixels;
							//set text position, alignment and color
							var greenBarWidth = parseInt(overlayGreenWidth + runsProgressPixels,10);
							var statusTextStyle = "";
							if(greenBarWidth > runsProgressTextWidthPixel){
								runnerTextLeft = runnerLeft - runsProgressTextWidthPixel + 20;
								statusTextStyle = "width:"+runsProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:right;color:#FFFFFF";
							}
							else{
								runnerTextLeft = runnerLeft + 28;
								statusTextStyle = "width:"+runsProgressTextWidthPixel+"px;left:"+runnerTextLeft+"px;text-align:left;color:#333333";
							}
							html += 
								"<div id=\"progressBarOverlayGreenStart\"></div>"+
								"<div id=\"progressBarOverlayGreenSections\" style=\"width:"+runsProgressPixels+"px\"></div>"+
								"<div id=\"progressBarOverlayWhiteLine\" style=\"left:"+whiteDelimiterLeft+"px\"></div>"+
								"<div id=\"progressBarProgressStatusText\" style=\""+statusTextStyle+"\">"+runsProgressText+"</div>";
						}
						
						html +=	
							"<div id=\"progressBarOverlayTargetBubble\" style=\"left:"+targetLeft+"px\"></div>"+
							"<div id=\"progressBarOverlayRunnerBubble\" style=\"left:"+runnerLeft+"px\"></div>";
					}
					break;
			}
			return html;
		}
	}
}



function getDisplayDistance(displayUnit,comparatorValue){
	if(displayUnit == "mi"){
		kmToMiles = comparatorValue / 1.609344;
		kmToMiles = setPrecision(kmToMiles+"",2);
		return kmToMiles;
	}
	else{
		km = setPrecision(comparatorValue,2);
		return km;
	}
}

function getDisplayText(msgKey){
	switch(msgKey){
		case "mi":
			return "miles";
			break;
		case "km":
			return "kilometres";
			break;
		default:
			return msgKey;
	}
}

function openNikePlusWithToken(pin){
    serviceURL = "https://www.nike.com/nikeplus/v1/services/widget/generate_token.jhtml";
    reqGetToken = new XMLHttpRequest();
    reqGetToken.onreadystatechange = openNikePlusWithTokenChange;
    reqGetToken.open("POST", serviceURL, true);
    reqGetToken.setRequestHeader("pin", pin);
    reqGetToken.send(null);
}
 
function openNikePlusWithTokenChange(){
    if (reqGetToken.readyState == 4) {
        if (reqGetToken.status == 200) {
			debug("got token response to link to nike");
            var serviceStatus =  reqGetToken.responseXML.getElementsByTagName("status")[0].firstChild.data;
            if(serviceStatus == "success"){
                var token =  reqGetToken.responseXML.getElementsByTagName("token")[0].firstChild.data;
				debug(token);
				goalID = getlastGoalIDPreference();
                if(goalID != ""){
                    widget.openURL("http://www.nike.com/nikeplus/?l=goals,"+goalID+"&token="+token);
                }
                else{
                    widget.openURL("http://www.nike.com/nikeplus/?token="+token);
                }
            }
            else{
                widget.openURL("http://www.nikeplus.com");
            }
        }
        else{
            widget.openURL("http://www.nikeplus.com");;
        }
    }
    else if(reqGetToken.readyState == 0){
        widget.openURL("http://www.nikeplus.com");
    }
}
