/*
author>
            Matthias Hader (R/GA)
            Nick Coronges (R/GA)
            Jeff Baxter (R/GA) - Design
</author>
<company>NIKE</company>
<copyright>(c)2006 NIKE ALL RIGHTS RESERVED</copyright>
 */
var usernamePref = "nikeplusUsername";
var passwordPref = "nikeplusPassword";
var pinPref = "nikeplusPin";
var lastGoalIDPref = "nikeplusLastGoalID";

function onShowDashboard(){
	debug("show dashboard");
	validateWidget();
}

function onClickSwoosh(){
	debug('swoosh clicked');
	if(window.widget){
		pin = getPinPreference();
		debug('pin for login '+pin);
		if(pin != ""){
			openNikePlusWithToken(pin);
		}
		else{
			widget.openURL("http://www.nikeplus.com");
		}
	}
}

function getUsernamePreference(){
	var username = widget.preferenceForKey(usernamePref);
	if (!username || (username == "undefined")) {username = "";}
	return username;
}

function getPinPreference(){
	var pin = widget.preferenceForKey(pinPref);
	if (!pin || (pin == "undefined")) {pin = "";}
	return pin;
}

function getlastGoalIDPreference(){
	lastGoalID = widget.preferenceForKey(lastGoalIDPref);
	if (!lastGoalID || (lastGoalID == "undefined")) {lastGoalID = "";}
	return lastGoalID;
}

function setUsernamePreference(username){
	widget.setPreferenceForKey(username,usernamePref);
}

function setPinPreference(pin){
	widget.setPreferenceForKey(pin,pinPref);
}

function setLastGoalIDPreference(goalID){
	widget.setPreferenceForKey(goalID,lastGoalIDPref);
}

function hideGoalSelector(){
	document.getElementById('goalSelectContainer').style.display = 'none';
}

function showGoalSelector(){
	document.getElementById('goalSelectContainer').style.display = 'block';
}

function prepareLogout(){
	flushDebug();
	processLogout();
	//delete all the preferences
	if(window.widget){
		setUsernamePreference(null);
		setPinPreference(null);
		setLastGoalIDPreference(null);
	}
	//hide the done button
	hideDoneButton();
	//hide dropdown
	hideGoalSelector();
	//show Login Button
	showLoginButton();
	//and now start from the first point and setup
	setup();
}

function prepareLogin(){
	debug("prepare login");
	var username = document.getElementById("usernameField").value;
	var password = document.getElementById("passwordField").value;
	document.getElementById("passwordField").value = "";
	if(window.widget){
		setUsernamePreference(username);
		setPinPreference(null);
		setLastGoalIDPreference(null);
	}
	hideLoginButton();
	processLogin(username,password);
}

function disableInputFields(){
	document.getElementById("usernameField").setAttribute("readonly","readonly");
	document.getElementById("passwordField").setAttribute("readonly","readonly");
}

function enableInputFields(){
	document.getElementById("usernameField").removeAttribute("readonly");
	document.getElementById("passwordField").removeAttribute("readonly");
}

function getGoalSelectBox(GoalDOM){
	html = 	"<div class=\"label\" id=\"selectGoalLabel\">Select a Goal</div>"+
			"<select size=\"1\" id=\"selectGoalField\" onchange=\"setSelectedGoal();\">"+
			"<option value=\"0\">Select a Goal...</option>";
	activeGoals = "";
	completedGoals = "";
	activeCount = 0;
	completedCount = 0;
	lastSelectedGoalID = ""
	if(window.widget) lastSelectedGoalID = getlastGoalIDPreference();
	var goalNodeIterator = GoalDOM.getElementsByTagName("goal");
	debug("goals node iterator: "+goalNodeIterator.length);
	if(goalNodeIterator.length == 0){
		return "";
	}
	for(var i=0;i<goalNodeIterator.length;i++){
		var goalID = GoalDOM.getElementsByTagName("goal")[i].getAttribute("id");
		var goalCompleted = GoalDOM.getElementsByTagName("goal")[i].childNodes[1].firstChild.data;
		//bad solution, but the defintion node is sometimes 9th sometimes 11th child
		var goalDefinitionNode = GoalDOM.getElementsByTagName("definition")[i];
		var startTime = GoalDOM.getElementsByTagName("goal")[i].childNodes[5].firstChild.data;
		var endTime = GoalDOM.getElementsByTagName("goal")[i].childNodes[7].firstChild.data;
		if(goalCompleted!="true"){
			activeCount++;
			if(goalID == lastSelectedGoalID){
				showDoneButton();
				activeGoals += "<option value=\""+goalID+"\" selected>"+getGoalTitle(goalDefinitionNode,startTime,endTime)+"</option>";
			}
			else{
				activeGoals += "<option value=\""+goalID+"\">"+getGoalTitle(goalDefinitionNode,startTime,endTime)+"</option>";
			}
		}
		else{
			completedCount++;
			if(goalID == lastSelectedGoalID){
				showDoneButton();
				completedGoals += "<option value=\""+goalID+"\" selected>"+getGoalTitle(goalDefinitionNode,startTime,endTime)+"</option>";
			}
			else{
				completedGoals += "<option value=\""+goalID+"\">"+getGoalTitle(goalDefinitionNode,startTime,endTime)+"</option>";
			}
		}
	}
	
	html += "<optgroup label=\"Incomplete ("+activeCount+")\">"+
				activeGoals+
			"</optgroup>"+
			"<optgroup label=\"Completed ("+completedCount+")\">"+
				completedGoals+
			"</optgroup>"+
		"</select>";	
	return html;
}

function getGoalTitle(goalDefinitonNode,startTime,endTime){
	var goalType = goalDefinitonNode.childNodes[1].firstChild.data;
	var weekDifference = getWeekDifference(startTime,endTime);
	//alert(weekDifference);
	switch(goalType){
		case "runCalories":
			var caloriesGoal = goalDefinitonNode.childNodes[3].firstChild.data;
			var goalTitle = "Burn "+caloriesGoal+" calories in "+weekDifference+" weeks. (To Burn Calories)";
			return goalTitle;
			break;
		case "runFurther":
			var distanceGoal = goalDefinitonNode.childNodes[3].firstChild.data;
			var displayUnit = goalDefinitonNode.childNodes[5].firstChild.data;
			var distanceGoalDisplayed = Math.round(getDisplayDistance(displayUnit,distanceGoal));
			var displayUnitText = getDisplayText(displayUnit);
			var goalTitle = "Run "+distanceGoalDisplayed+" "+displayUnitText+" in "+weekDifference+" weeks. (A Distance)";
			return goalTitle;
			break;
		case "runFaster": 
			var numberOfRunsGoal = goalDefinitonNode.childNodes[3].firstChild.data;
			var paceInMillis = goalDefinitonNode.childNodes[7].firstChild.data;
			var paceDisplay = getTimeInPrimeFormatFromMilliSeconds(paceInMillis);
			var goalTitle = "Run "+numberOfRunsGoal+" runs under the avg. pace of "+paceDisplay+" in a month. (Faster)";
			return goalTitle;
		case "runMoreOften":
			var numberOfRunsGoal = goalDefinitonNode.childNodes[3].firstChild.data;
			var goalTitle = "Run "+numberOfRunsGoal+" times in "+weekDifference+" weeks. (More Often)";
			return goalTitle;
			break;
		default:
			return "-";
	}
}

function setSelectedGoal(){
	g_selectedGoalID = document.getElementById("selectGoalField").options[document.getElementById("selectGoalField").selectedIndex].value;
	var selectedText = document.getElementById("selectGoalField").options[document.getElementById("selectGoalField").selectedIndex].text;
	g_selectedGoalTitle = selectedText.split("\. (")[0]+".";
	if(g_selectedGoalID!=0){
		setLastGoalIDPreference(g_selectedGoalID);
		loadNewGoalData(g_selectedGoalID,g_goalDetailDOM,g_selectedGoalTitle);
		showDoneButton();
	}
	else{
		popUpMessageBox(true,"Something wasn't quite right. Please choose a Goal.");
	}
}

function loadNewGoalData(goalID,goalDOM,goalTitle){
	document.getElementById("goalHeadlineContainer").innerHTML =
		"<div id=\"goalTitleContainer\">"+goalTitle+"</div>"+
		"<div id=\"goalSubtitleContainer\">"+getGoalSubtitle(goalID,goalDOM)+"</div>";
	document.getElementById("goalDetailContainer").innerHTML = getGoalDetail(g_goalDetailDOM,goalID);
}
